## [3.3.688] - 20230209

### 新增

1. 日志默认写入当前目录的子目录`xtf-api-log/`；



## [3.3.686] - 20230208

### 修复

1. 修复UDP通信打开失败后，无法自动重连的问题；
2. 修复Release接口重复调用时没有空指针保护的问题；



## [3.3.669] - 20230202

### 新增

1. Release版本增加Info级别的日志记录；



## [3.3.656] - 20230117

### 优化

1. 优化OnFrontDisconnected()接口，返回断开的原因；



### 修复

1. 修复Release()接口释放是出现异常访问的问题；



## [3.3.653] - 20230112

### 新增

1. 增加userdemo2；



## [3.3.648] - 20230106

### 修复

1. 修复CXeleTraderApi类信息未导出的问题；
2. 修复userdemo中撤单失败的问题；



## [3.3.641] - 20221230

### 修复

1. 发送TCP数据时增加多线程同步机制，以防数据交替发送造成异常；
2. 修复不带后缀_1的账号登出后无法再次登录的问题，以及无法本地查询的问题；



## [3.3.618] - 20221209

### 优化

1. 增加报单接口`多线程不安全`的注释说明；



## [3.3.598] - 20221201

### 修复

1. 修复查询持仓在错误的场景下无回调的问题；



## [3.3.586] - 20221122

### 新增

1. 取消RequestID最高4bit全1的限制（RequestID不能为-1）；
2. 增加对柜台版本的校验，对于版本号过低的柜台，提示不兼容；
3. 账户字段AccountID和UserID扩展为20字节；涉及的数据类型包括：
   登录请求: CXeleFtdcReqUserLoginField结构，AccountID字段修改为20字节
   登录响应: CXeleFtdcRspUserLoginField结构，AccountID字段修改为20字节
   登出请求: CXeleFtdcReqUserLogoutField结构，AccountID字段修改为20字节
   登出响应: CXeleFtdcRspUserLogoutField结构，AccountID字段修改为20字节
   更新密码请求/响应: CXeleFtdcUserPasswordUpdateField结构，AccountID字段修改为20字节
   报单查询请求: CXeleFtdcQryOrderField结构，AccountID字段修改为20字节
   成交查询请求: CXeleFtdcQryTradeField结构，AccountID字段修改为20字节
   持仓查询请求: CXeleFtdcQryClientPositionField结构，AccountID字段修改为20字节
   持仓查询响应: CXeleFtdcRspClientPositionField结构，AccountID字段修改为20字节
   成交回报: CXeleFtdcTradeField结构，AccountID字段、UserID修改为20字节
   资金查询请求: CXeleFtdcQryClientAccountField结构，AccountID字段修改为20字节
   资金查询响应: CXeleFtdcRspClientAccountField结构，AccountID字段修改为20字节
   合约保证金率查询请求: CXeleFtdcQryInstrumentMarginRateField结构，AccountID字段修改为20字节
   合约保证金率查询响应: CXeleFtdcRspInstrumentMarginRateField结构，AccountID字段修改为20字节
   合约手续费率查询请求: CXeleFtdcQryInstrumentCommissionRateField结构，AccountID字段修改为20字节
   合约手续费率查询响应: CXeleFtdcRspInstrumentCommissionRateField结构，AccountID字段修改为20字节
   出入金流水通知: CXeleFtdcSeqDepositField结构，AccountID字段修改为20字节报单
   输入响应结构体: CXeleFtdcInputOrderField，UserID 修改为20字节
   报单操作响应结构体: CXeleFtdcOrderActionField，UserID 修改为20字节
   报单回报结构体: CXeleFtdcOrderField，UserID 修改为20字节 ActiveUserID 修改为20字节
   组合回报结构体: CXeleFtdcCombOrderField，UserID 修改为20字节



### 版本升级说明

1. 如果应用程序通过结构体成员变量的方式进行处理，那么只需要更新配套头文件和二进制库文件即可；
2. 如果应用程序通过字段偏移的方式进行取值，那么需要仔细核对AccountID字段的处理逻辑，变更对应的偏移量；




## [3.3.546] - 20221107

### 增加

1. 增加组合仓位查询功能；



### 优化

1. 日出流水数据推送处理优化，兼容未知消息类型的数据报处理；



## [3.3.479] - 20221011

### 优化

1. UDP预热报单优化；



## [3.3.465] - 20220927

### 修复

1. 修复问题：重复登录报错后，无法进行正常报单操作，收不到报单响应；



## [3.3.454] - 20220927

### 修复
1. 修复对外公开的结构体构造函数未导出，链接时失败的问题。



## [3.3.276] - 20220823

### 新增

1. 新增合约序号查询方法ReqQryInstrumentIndex，裸协议报单用户关心，API报单可忽略
2. 新增合约涨跌停价查询方法GetInstrumentIndex，裸协议报单用户关心，API报单可忽略
3. 新增获取客户令牌接口方法GetClientToken，裸协议报单用户关心，API报单可忽略
4. 新增合约序号查询应答接口方法OnRspQryInstrumentIndex，裸协议报单用户关心，API报单可忽略
5. 新增历史报单回报方法OnRtnHistoryOrder，裸协议报单用户关心，API报单可忽略
6. 新增历史成交回报方法OnRtnHistoryTrade，裸协议报单用户关心，API报单可忽略



## [3.3.211] - 20220622

### 新增

1. Xele-Trade-Futures柜台4.1版本发布，提供兼容原3.2版本API的接口（3.3版本）；
   1. 3.2版本API需要更换3.3版本的头文件与库后重新编译即可。
   2. 用户发送登录请求后，柜台会向API推送流水（内部实现，可忽略）；
   3. 历史回报接收完成后，才会返回登录响应OnRspUserLogin，建议增加登录超时时间或调用OnRtnHistoryOrder、OnRtnHistoryTrade判断流水是否结束。

